/**
 * ENSICAEN
 * 6 Boulevard Maréchal Juin
 * F-14050 Caen Cedex
 *
 * This file is owned by ENSICAEN students. No portion of this
 * document may be reproduced, copied or revised without written
 * permission of the authors.
 */

/**
 * @author  Dimitri Boudier <dimitri.boudier@ensicaen.fr>
 * @author
 * @author
 * @version 1.0.0 - 2023-10-14
 *
 * @todo    Nothing.
 * @bug     None.
 * @note    This driver can be used with only ONE Accel 2 click at once.
 */

/**
 * @file accel_2_click.c
 * @brief Driver for the MIKROE "Accel 2 click" board
 *
 * Ref. https://www.mikroe.com/accel-2-click
 */


#include "main.h"
#include "accel_2_click.h"



/*****************************************************************************
 * GLOBAL VARIABLE DEFINITIONS
 *****************************************************************************/

//! UART2 peripheral handle for debug purpose
extern UART_HandleTypeDef huart2;

//! Declared as global in order to be seen by all the driver functions.
ACCEL_2_handle_t accel_2_handle;



/*****************************************************************************
 * FUNCTION DEFINITIONS
 *****************************************************************************/

void ACCEL_2_init(SPI_HandleTypeDef *hspi, GPIO_TypeDef *SS_Port, uint16_t SS_Pin)
{

	/**
	 * @TODO (1) Accel 2 handle initialization
	 * - Attach the SPI peripheral handle
	 * - Attach the GPIO pin used for the SS signal
	 */
	 

	/**
	 * @TODO (2) Accel 2 click identification
	 * Read the WHO AM I register. If the received value is wrong:
	 *  - send an error message to UART2
	 *  - stay blocked in this function (waiting for the user to reset the MCU)
	 */
	 

	/**
	 * @TODO (3) Accel 2 click configuration
	 * - Enable all three axes with
	 * - Set an output data rate other than off
	 */
	 

	/**
	 * @TODO (4) Accel 2 click configuration
	 * - Set the anti-aliasing filter bandwidth
	 * - Set the full-scale
	 * - Set the SPI mode
	 * - Deactivate the self-test
	 */
}


void ACCEL_2_writeReg(uint8_t reg_addr, uint8_t reg_value)
{
	//! @TODO
}


void ACCEL_2_readReg(uint8_t reg_addr, uint8_t* reg_value, uint8_t n_bytes)
{
	//! @TODO
}


void ACCEL_2_readX(float* x_value)
{
	//! @TODO	(1) Read the x-axis acceleration value from the LIS3DSH

	//! @TODO	(2) Convert the two bytes into a float

	//! @TODO   (3) Convert the acceleration value from no-unit to g-unit
	
	//! @TODO   (4) Read the full-scale value

	//! @TODO   (5) Apply the sensitivity coefficient depending on the full-scale
	//! @note   a switch-case block would fit nicely here
}


void ACCEL_2_readY(float* y_value)
{
	//! @TODO	(1) Read the y-axis acceleration value from the LIS3DSH

	//! @TODO	(2) Convert the two bytes into a float

	//! @TODO   (3) Convert the acceleration value from no-unit to g-unit

	//! @TODO   (4) Read the full-scale value

	//! @TODO   (5) Apply the sensitivity coefficient depending on the full-scale
	//! @note   a switch-case block would fit nicely here
}


void ACCEL_2_readZ(float* z_value)
{
	//! @TODO	(1) Read the z-axis acceleration value from the LIS3DSH

	//! @TODO	(2) Convert the two bytes into a float

	//! @TODO   (3) Convert the acceleration value from no-unit to g-unit

	//! @TODO   (4) Read the full-scale value

	//! @TODO   (5) Apply the sensitivity coefficient depending on the full-scale
	//! @note   a switch-case block would fit nicely here
}


void ACCEL_2_readXYZ(float* x_value, float* y_value, float* z_value)
{
	//! @TODO	(1) Read the 3-axes acceleration values from the LIS3DSH

	//! @TODO	(2) Convert the two bytes into a float

	//! @TODO   (4) Read the full-scale value

	//! @TODO   (5) Apply the sensitivity coefficient depending on the full-scale
	//! @note   a switch-case block would fit nicely here
}

